'use strict';

define("dummy/tests/helpers/register-module", ["exports"], function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = registerModule;
  const semiRandom = Date.now();
  let i = 0;

  function registerModule(moduleExports) {
    const semiRandomModuleName = "random-module/".concat(semiRandom, "/").concat(i++);
    define.exports(semiRandomModuleName, moduleExports);
    return semiRandomModuleName;
  }
});
define("dummy/tests/integration/helpers/local-class-test", ["@ember/test-helpers", "ember-qunit", "qunit", "dummy/tests/helpers/register-module"], function (_testHelpers, _emberQunit, _qunit, _registerModule) {
  "use strict";

  (0, _qunit.module)('Integration | Helper | local-class', function (hooks) {
    (0, _emberQunit.setupRenderingTest)(hooks);
    (0, _qunit.test)('it passes through context-less local classes without processing', async function (assert) {
      var _temp;

      this.owner.register('service:makeup', (_temp = class MakeupServiceMock extends Ember.Service.extend(Ember.Evented) {
        constructor(...args) {
          super(...args);
          this.classNamePrefix = 'some-class-name-prefix/';
        }

        resolveContext() {
          throw new Error('Should not be called');
        }

      }, _temp));
      this.moduleName = (0, _registerModule.default)({
        default: {
          foo: 'bar qux'
        }
      });
      await (0, _testHelpers.render)(Ember.HTMLBars.template({
        "id": "m43W3ifA",
        "block": "{\"symbols\":[],\"statements\":[[1,[29,\"local-class\",[\"foo\"],[[\"from\"],[[24,0,[\"moduleName\"]]]]],false]],\"hasEval\":false}",
        "meta": {}
      }));
      assert.equal(this.element.textContent.trim(), 'bar qux');
    });
    (0, _qunit.test)('it passes through context-less local classes and resolves context classes', async function (assert) {
      var _temp2;

      let flavor = 'light';
      this.owner.register('service:makeup', (_temp2 = class MakeupServiceMock extends Ember.Service.extend(Ember.Evented) {
        constructor(...args) {
          super(...args);
          this.classNamePrefix = 'some-class-name-prefix/';
        }

        resolveContext(key) {
          return "context-".concat(flavor, "-").concat(key);
        }

      }, _temp2));
      this.moduleName = (0, _registerModule.default)({
        default: {
          foo: 'bar some-class-name-prefix/baz qux some-class-name-prefix/quax'
        }
      });
      await (0, _testHelpers.render)(Ember.HTMLBars.template({
        "id": "m43W3ifA",
        "block": "{\"symbols\":[],\"statements\":[[1,[29,\"local-class\",[\"foo\"],[[\"from\"],[[24,0,[\"moduleName\"]]]]],false]],\"hasEval\":false}",
        "meta": {}
      }));
      assert.equal(this.element.textContent.trim(), 'bar context-light-baz qux context-light-quax', 'resolves context classes');
      flavor = 'dark';
      this.owner.lookup('service:makeup').trigger('theme-change');
      Ember.run.begin();
      Ember.run.end();
      await (0, _testHelpers.settled)();
      assert.equal(this.element.textContent.trim(), 'bar context-dark-baz qux context-dark-quax', 'updates on `theme-change` event');
    });
  });
});
define("dummy/tests/test-helper", ["@ember/test-helpers", "ember-qunit", "dummy/app", "dummy/config/environment"], function (_testHelpers, _emberQunit, _app, _environment) {
  "use strict";

  (0, _testHelpers.setApplication)(_app.default.create(_environment.default.APP));
  (0, _emberQunit.start)();
});
define("dummy/tests/unit/services/makeup-test", ["ember-qunit", "qunit"], function (_emberQunit, _qunit) {
  "use strict";

  (0, _qunit.module)('Unit | Service | makeup', function (hooks) {
    (0, _emberQunit.setupTest)(hooks); // Replace this with your real tests.

    (0, _qunit.test)('it exists', function (assert) {
      const service = this.owner.lookup('service:makeup');
      assert.ok(service);
    });
  });
});
define('dummy/config/environment', [], function() {
  var prefix = 'dummy';
try {
  var metaName = prefix + '/config/environment';
  var rawConfig = document.querySelector('meta[name="' + metaName + '"]').getAttribute('content');
  var config = JSON.parse(decodeURIComponent(rawConfig));

  var exports = { 'default': config };

  Object.defineProperty(exports, '__esModule', { value: true });

  return exports;
}
catch(err) {
  throw new Error('Could not read config from meta tag with name "' + metaName + '".');
}

});

require('dummy/tests/test-helper');
EmberENV.TESTS_FILE_LOADED = true;
//# sourceMappingURL=tests.map
