define("ember-makeup/helpers/local-class", ["exports", "ember-css-modules/helpers/local-class"], function (_exports, _localClass) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.default = void 0;

  var _class, _descriptor, _temp;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and set to use loose mode. ' + 'To use proposal-class-properties in spec mode with decorators, wait for ' + 'the next major version of decorators in stage 2.'); }

  let LocalClassHelper = (_class = (_temp = class LocalClassHelper extends Ember.Helper {
    constructor(...args) {
      super(...args);

      _initializerDefineProperty(this, "makeup", _descriptor, this);

      this.hasContexts = false;
    }

    init() {
      super.init();
      this.makeup.on('theme-change', this.onThemeChange);
    }

    willDestroy() {
      super.willDestroy();
      this.makeup.off('theme-change', this.onThemeChange);
    }

    onThemeChange() {
      // @TODO: https://github.com/emberjs/ember.js/issues/14774
      if (this.hasContexts) Ember.run.join(() => this.recompute());
    }

    compute(params, named) {
      const localClasses = (0, _localClass.localClass)(params, named);
      const {
        classNamePrefix
      } = this.makeup; // If the magic context class name prefix is not contained in the class
      // list, just pass through the unchanged local classes.

      this.hasContexts = localClasses.includes(classNamePrefix);
      if (!this.hasContexts) return localClasses; // Forward all regular local classes and resolve all context classes.

      return localClasses.split(' ').map(className => className.startsWith(classNamePrefix) ? this.makeup.resolveContext(className.slice(classNamePrefix.length)) : className).join(' ');
    }

  }, _temp), (_descriptor = _applyDecoratedDescriptor(_class.prototype, "makeup", [Ember.inject.service], {
    configurable: true,
    enumerable: true,
    writable: true,
    initializer: null
  }), _applyDecoratedDescriptor(_class.prototype, "onThemeChange", [Ember._action], Object.getOwnPropertyDescriptor(_class.prototype, "onThemeChange"), _class.prototype)), _class);
  _exports.default = LocalClassHelper;
});