"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const cssesc_1 = __importDefault(require("cssesc"));
const CONFIG_KEY_REGEX = /^[\w-.]+$/i;
const ROOT_CONFIG_KEY_REGEX = /^\/[\w-.]+$/i;
exports.isValidResolvedConfigKey = (string) => CONFIG_KEY_REGEX.test(string);
exports.isValidRootConfigKey = (string) => ROOT_CONFIG_KEY_REGEX.test(string);
exports.isValidConfigKey = (string) => exports.isValidResolvedConfigKey(string) || exports.isValidRootConfigKey(string);
exports.containsQuotes = (string) => string.includes('"') || string.includes("'") || string.includes('`');
exports.resolveRootConfigKey = (key) => key.slice(1);
exports.serializeConfigKey = (key) => `--${cssesc_1.default(key, { isIdentifier: true })}`;
exports.isContextKey = (key) => key.startsWith('$');
exports.contextFromContextKey = (key) => key.slice(1);
