"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const broccoli_postcss_1 = __importDefault(require("broccoli-postcss"));
const cfg_to_var_1 = __importDefault(require("../postcss/cfg-to-var"));
class PostPlugin {
    constructor(owner) {
        // eslint-disable-next-line unicorn/prevent-abbreviations
        this.ext = ['css', 'yml'];
        this.name = 'ember-makeup:post';
        this.owner = owner;
    }
    toTree(tree, _inputDirectory, _outputDirectory, _options) {
        const cfgToVarTree = broccoli_postcss_1.default(tree, {
            browsers: this.owner.project.targets.browsers,
            plugins: [
                {
                    module: cfg_to_var_1.default,
                    options: {
                    // reportUsage(usage: Usage) {
                    //   console.log(usage);
                    // }
                    }
                }
            ]
        });
        return this.owner.debugTree(cfgToVarTree, 'post-plugin');
    }
}
exports.default = PostPlugin;
