"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
function register(owner, type, registry) {
    if (type !== 'parent')
        return;
    const TYPE = 'css';
    // Get a list of all already registered plugins.
    const registeredPlugins = [...registry.registeredForType(TYPE)];
    // Remove all already registered plugins.
    for (const plugin of registeredPlugins)
        registry.remove(TYPE, plugin);
    // Put the PrePlugin first.
    registry.add(TYPE, new _1.PrePlugin(owner));
    // Add all removed plugins back in.
    for (const plugin of registeredPlugins)
        registry.add(TYPE, plugin);
    // Add the PostPlugin.
    // The list now looks like: [PrePlugin, ..., PostPlugin]
    registry.add(TYPE, new _1.PostPlugin(owner));
}
exports.register = register;
